=begin
#Mandrill API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0
Contact: apihelp@mandrill.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'uri'

module MailchimpTransactional
  class TransactionalApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # /exports/activity
    # Begins an export of your activity history. The activity will be exported to a zip archive containing a single file named activity.csv in the same format as you would be able to export from your account's activity view. It includes the following fields: Date, Email Address, Sender, Subject, Status, Tags, Opens, Clicks, Bounce Detail. If you have configured any custom metadata fields, they will be included in the exported data.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2004]
    def post_exports_activity(body, opts = {})
      data, _status_code, _headers = post_exports_activity_with_http_info(body, opts)
      data
    end

    # /exports/activity
    # Begins an export of your activity history. The activity will be exported to a zip archive containing a single file named activity.csv in the same format as you would be able to export from your account&#39;s activity view. It includes the following fields: Date, Email Address, Sender, Subject, Status, Tags, Opens, Clicks, Bounce Detail. If you have configured any custom metadata fields, they will be included in the exported data.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2004, Fixnum, Hash)>] InlineResponse2004 data, response status code and response headers
    def post_exports_activity_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_exports_activity ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_exports_activity"
      end
      # resource path
      local_var_path = '/exports/activity'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2004')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_exports_activity\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /exports/info
    # Returns information about an export job. If the export job's state is 'complete', the returned data will include a URL you can use to fetch the results. Every export job produces a zip archive, but the format of the archive is distinct for each job type. The api calls that initiate exports include more details about the output format for that job type.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse200]
    def post_exports_info(body, opts = {})
      data, _status_code, _headers = post_exports_info_with_http_info(body, opts)
      data
    end

    # /exports/info
    # Returns information about an export job. If the export job&#39;s state is &#39;complete&#39;, the returned data will include a URL you can use to fetch the results. Every export job produces a zip archive, but the format of the archive is distinct for each job type. The api calls that initiate exports include more details about the output format for that job type.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse200, Fixnum, Hash)>] InlineResponse200 data, response status code and response headers
    def post_exports_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_exports_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_exports_info"
      end
      # resource path
      local_var_path = '/exports/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse200')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_exports_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /exports/list
    # Returns a list of your exports.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2001>]
    def post_exports_list(body, opts = {})
      data, _status_code, _headers = post_exports_list_with_http_info(body, opts)
      data
    end

    # /exports/list
    # Returns a list of your exports.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2001>, Fixnum, Hash)>] Array<InlineResponse2001> data, response status code and response headers
    def post_exports_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_exports_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_exports_list"
      end
      # resource path
      local_var_path = '/exports/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2001>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_exports_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /exports/rejects
    # Begins an export of your rejection blacklist. The blacklist will be exported to a zip archive containing a single file named rejects.csv that includes the following fields: email, reason, detail, created_at, expires_at, last_event_at, expires_at.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2002]
    def post_exports_rejects(body, opts = {})
      data, _status_code, _headers = post_exports_rejects_with_http_info(body, opts)
      data
    end

    # /exports/rejects
    # Begins an export of your rejection blacklist. The blacklist will be exported to a zip archive containing a single file named rejects.csv that includes the following fields: email, reason, detail, created_at, expires_at, last_event_at, expires_at.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2002, Fixnum, Hash)>] InlineResponse2002 data, response status code and response headers
    def post_exports_rejects_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_exports_rejects ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_exports_rejects"
      end
      # resource path
      local_var_path = '/exports/rejects'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2002')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_exports_rejects\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /exports/whitelist
    # Begins an export of your rejection whitelist. The whitelist will be exported to a zip archive containing a single file named whitelist.csv that includes the following fields: email, detail, created_at.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2003]
    def post_exports_whitelist(body, opts = {})
      data, _status_code, _headers = post_exports_whitelist_with_http_info(body, opts)
      data
    end

    # /exports/whitelist
    # Begins an export of your rejection whitelist. The whitelist will be exported to a zip archive containing a single file named whitelist.csv that includes the following fields: email, detail, created_at.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2003, Fixnum, Hash)>] InlineResponse2003 data, response status code and response headers
    def post_exports_whitelist_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_exports_whitelist ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_exports_whitelist"
      end
      # resource path
      local_var_path = '/exports/whitelist'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2003')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_exports_whitelist\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/add-domain
    # Add a new template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2006]
    def post_inbound_add_domain(body, opts = {})
      data, _status_code, _headers = post_inbound_add_domain_with_http_info(body, opts)
      data
    end

    # /inbound/add-domain
    # Add a new template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2006, Fixnum, Hash)>] InlineResponse2006 data, response status code and response headers
    def post_inbound_add_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_add_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_add_domain"
      end
      # resource path
      local_var_path = '/inbound/add-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2006')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_add_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/add-route
    # Add a new mailbox route to an inbound domain
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20010]
    def post_inbound_add_route(body, opts = {})
      data, _status_code, _headers = post_inbound_add_route_with_http_info(body, opts)
      data
    end

    # /inbound/add-route
    # Add a new mailbox route to an inbound domain
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20010, Fixnum, Hash)>] InlineResponse20010 data, response status code and response headers
    def post_inbound_add_route_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_add_route ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_add_route"
      end
      # resource path
      local_var_path = '/inbound/add-route'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20010')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_add_route\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/check-domain
    # Check the MX settings for an inbound domain. The domain must have already been added with the add-domain call
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2007]
    def post_inbound_check_domain(body, opts = {})
      data, _status_code, _headers = post_inbound_check_domain_with_http_info(body, opts)
      data
    end

    # /inbound/check-domain
    # Check the MX settings for an inbound domain. The domain must have already been added with the add-domain call
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2007, Fixnum, Hash)>] InlineResponse2007 data, response status code and response headers
    def post_inbound_check_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_check_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_check_domain"
      end
      # resource path
      local_var_path = '/inbound/check-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2007')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_check_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/delete-domain
    # Delete an inbound domain from the account. All mail will stop routing for this domain immediately.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse2008]
    def post_inbound_delete_domain(body, opts = {})
      data, _status_code, _headers = post_inbound_delete_domain_with_http_info(body, opts)
      data
    end

    # /inbound/delete-domain
    # Delete an inbound domain from the account. All mail will stop routing for this domain immediately.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse2008, Fixnum, Hash)>] InlineResponse2008 data, response status code and response headers
    def post_inbound_delete_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_delete_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_delete_domain"
      end
      # resource path
      local_var_path = '/inbound/delete-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2008')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_delete_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/delete-route
    # Delete an existing inbound mailbox route
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20012]
    def post_inbound_delete_route(body, opts = {})
      data, _status_code, _headers = post_inbound_delete_route_with_http_info(body, opts)
      data
    end

    # /inbound/delete-route
    # Delete an existing inbound mailbox route
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20012, Fixnum, Hash)>] InlineResponse20012 data, response status code and response headers
    def post_inbound_delete_route_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_delete_route ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_delete_route"
      end
      # resource path
      local_var_path = '/inbound/delete-route'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20012')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_delete_route\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/domains
    # Add an inbound domain to your account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2005>]
    def post_inbound_domains(body, opts = {})
      data, _status_code, _headers = post_inbound_domains_with_http_info(body, opts)
      data
    end

    # /inbound/domains
    # Add an inbound domain to your account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2005>, Fixnum, Hash)>] Array<InlineResponse2005> data, response status code and response headers
    def post_inbound_domains_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_domains ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_domains"
      end
      # resource path
      local_var_path = '/inbound/domains'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2005>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_domains\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/routes
    # List the mailbox routes defined for an inbound domain
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse2009>]
    def post_inbound_routes(body, opts = {})
      data, _status_code, _headers = post_inbound_routes_with_http_info(body, opts)
      data
    end

    # /inbound/routes
    # List the mailbox routes defined for an inbound domain
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse2009>, Fixnum, Hash)>] Array<InlineResponse2009> data, response status code and response headers
    def post_inbound_routes_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_routes ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_routes"
      end
      # resource path
      local_var_path = '/inbound/routes'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse2009>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_routes\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/send-raw
    # Take a raw MIME document destined for a domain with inbound domains set up, and send it to the inbound hook exactly as if it had been sent over SMTP
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20013>]
    def post_inbound_send_raw(body, opts = {})
      data, _status_code, _headers = post_inbound_send_raw_with_http_info(body, opts)
      data
    end

    # /inbound/send-raw
    # Take a raw MIME document destined for a domain with inbound domains set up, and send it to the inbound hook exactly as if it had been sent over SMTP
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20013>, Fixnum, Hash)>] Array<InlineResponse20013> data, response status code and response headers
    def post_inbound_send_raw_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_send_raw ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_send_raw"
      end
      # resource path
      local_var_path = '/inbound/send-raw'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20013>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_send_raw\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /inbound/update-route
    # Update the pattern or webhook of an existing inbound mailbox route. If null is provided for any fields, the values will remain unchanged.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20011]
    def post_inbound_update_route(body, opts = {})
      data, _status_code, _headers = post_inbound_update_route_with_http_info(body, opts)
      data
    end

    # /inbound/update-route
    # Update the pattern or webhook of an existing inbound mailbox route. If null is provided for any fields, the values will remain unchanged.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20011, Fixnum, Hash)>] InlineResponse20011 data, response status code and response headers
    def post_inbound_update_route_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_inbound_update_route ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_inbound_update_route"
      end
      # resource path
      local_var_path = '/inbound/update-route'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20011')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_inbound_update_route\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/cancel-warmup
    # Cancels the warmup process for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20017]
    def post_ips_cancel_warmup(body, opts = {})
      data, _status_code, _headers = post_ips_cancel_warmup_with_http_info(body, opts)
      data
    end

    # /ips/cancel-warmup
    # Cancels the warmup process for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20017, Fixnum, Hash)>] InlineResponse20017 data, response status code and response headers
    def post_ips_cancel_warmup_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_cancel_warmup ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_cancel_warmup"
      end
      # resource path
      local_var_path = '/ips/cancel-warmup'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20017')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_cancel_warmup\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/check-custom-dns
    # Tests whether a domain name is valid for use as the custom reverse DNS for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20023]
    def post_ips_check_custom_dns(body, opts = {})
      data, _status_code, _headers = post_ips_check_custom_dns_with_http_info(body, opts)
      data
    end

    # /ips/check-custom-dns
    # Tests whether a domain name is valid for use as the custom reverse DNS for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20023, Fixnum, Hash)>] InlineResponse20023 data, response status code and response headers
    def post_ips_check_custom_dns_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_check_custom_dns ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_check_custom_dns"
      end
      # resource path
      local_var_path = '/ips/check-custom-dns'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20023')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_check_custom_dns\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/create-pool
    # Creates a pool and returns it. If a pool already exists with this name, no action will be performed.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20021]
    def post_ips_create_pool(body, opts = {})
      data, _status_code, _headers = post_ips_create_pool_with_http_info(body, opts)
      data
    end

    # /ips/create-pool
    # Creates a pool and returns it. If a pool already exists with this name, no action will be performed.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20021, Fixnum, Hash)>] InlineResponse20021 data, response status code and response headers
    def post_ips_create_pool_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_create_pool ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_create_pool"
      end
      # resource path
      local_var_path = '/ips/create-pool'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20021')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_create_pool\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/delete
    # Deletes a dedicated IP. This is permanent and cannot be undone.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20019]
    def post_ips_delete(body, opts = {})
      data, _status_code, _headers = post_ips_delete_with_http_info(body, opts)
      data
    end

    # /ips/delete
    # Deletes a dedicated IP. This is permanent and cannot be undone.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20019, Fixnum, Hash)>] InlineResponse20019 data, response status code and response headers
    def post_ips_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_delete"
      end
      # resource path
      local_var_path = '/ips/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20019')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/delete-pool
    # Deletes a pool. A pool must be empty before you can delete it, and you cannot delete your default pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20022]
    def post_ips_delete_pool(body, opts = {})
      data, _status_code, _headers = post_ips_delete_pool_with_http_info(body, opts)
      data
    end

    # /ips/delete-pool
    # Deletes a pool. A pool must be empty before you can delete it, and you cannot delete your default pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20022, Fixnum, Hash)>] InlineResponse20022 data, response status code and response headers
    def post_ips_delete_pool_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_delete_pool ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_delete_pool"
      end
      # resource path
      local_var_path = '/ips/delete-pool'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20022')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_delete_pool\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/info
    # Retrieves information about a single dedicated ip.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20015]
    def post_ips_info(body, opts = {})
      data, _status_code, _headers = post_ips_info_with_http_info(body, opts)
      data
    end

    # /ips/info
    # Retrieves information about a single dedicated ip.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20015, Fixnum, Hash)>] InlineResponse20015 data, response status code and response headers
    def post_ips_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_info"
      end
      # resource path
      local_var_path = '/ips/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20015')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/list
    # Lists your dedicated IPs.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20014>]
    def post_ips_list(body, opts = {})
      data, _status_code, _headers = post_ips_list_with_http_info(body, opts)
      data
    end

    # /ips/list
    # Lists your dedicated IPs.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20014>, Fixnum, Hash)>] Array<InlineResponse20014> data, response status code and response headers
    def post_ips_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_list"
      end
      # resource path
      local_var_path = '/ips/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20014>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/list-pools
    # Lists your dedicated IP pools.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20020>]
    def post_ips_list_pools(body, opts = {})
      data, _status_code, _headers = post_ips_list_pools_with_http_info(body, opts)
      data
    end

    # /ips/list-pools
    # Lists your dedicated IP pools.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20020>, Fixnum, Hash)>] Array<InlineResponse20020> data, response status code and response headers
    def post_ips_list_pools_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_list_pools ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_list_pools"
      end
      # resource path
      local_var_path = '/ips/list-pools'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20020>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_list_pools\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/pool-info
    # Describes a single dedicated IP pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20021]
    def post_ips_pool_info(body, opts = {})
      data, _status_code, _headers = post_ips_pool_info_with_http_info(body, opts)
      data
    end

    # /ips/pool-info
    # Describes a single dedicated IP pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20021, Fixnum, Hash)>] InlineResponse20021 data, response status code and response headers
    def post_ips_pool_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_pool_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_pool_info"
      end
      # resource path
      local_var_path = '/ips/pool-info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20021')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_pool_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/provision
    # Requests an additional dedicated IP for your account. Accounts may have one outstanding request at any time, and provisioning requests are processed within 24 hours.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20016]
    def post_ips_provision(body, opts = {})
      data, _status_code, _headers = post_ips_provision_with_http_info(body, opts)
      data
    end

    # /ips/provision
    # Requests an additional dedicated IP for your account. Accounts may have one outstanding request at any time, and provisioning requests are processed within 24 hours.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20016, Fixnum, Hash)>] InlineResponse20016 data, response status code and response headers
    def post_ips_provision_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_provision ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_provision"
      end
      # resource path
      local_var_path = '/ips/provision'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20016')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_provision\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/set-custom-dns
    # Configures the custom DNS name for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20024]
    def post_ips_set_custom_dns(body, opts = {})
      data, _status_code, _headers = post_ips_set_custom_dns_with_http_info(body, opts)
      data
    end

    # /ips/set-custom-dns
    # Configures the custom DNS name for a dedicated IP.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20024, Fixnum, Hash)>] InlineResponse20024 data, response status code and response headers
    def post_ips_set_custom_dns_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_set_custom_dns ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_set_custom_dns"
      end
      # resource path
      local_var_path = '/ips/set-custom-dns'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20024')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_set_custom_dns\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/set-pool
    # Moves a dedicated IP to a different pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20018]
    def post_ips_set_pool(body, opts = {})
      data, _status_code, _headers = post_ips_set_pool_with_http_info(body, opts)
      data
    end

    # /ips/set-pool
    # Moves a dedicated IP to a different pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20018, Fixnum, Hash)>] InlineResponse20018 data, response status code and response headers
    def post_ips_set_pool_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_set_pool ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_set_pool"
      end
      # resource path
      local_var_path = '/ips/set-pool'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20018')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_set_pool\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /ips/start-warmup
    # Begins the warmup process for a dedicated IP. During the warmup process, Mandrill will gradually increase the percentage of your mail that is sent over the warming-up IP, over a period of roughly 30 days. The rest of your mail will be sent over shared IPs or other dedicated IPs in the same pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20017]
    def post_ips_start_warmup(body, opts = {})
      data, _status_code, _headers = post_ips_start_warmup_with_http_info(body, opts)
      data
    end

    # /ips/start-warmup
    # Begins the warmup process for a dedicated IP. During the warmup process, Mandrill will gradually increase the percentage of your mail that is sent over the warming-up IP, over a period of roughly 30 days. The rest of your mail will be sent over shared IPs or other dedicated IPs in the same pool.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20017, Fixnum, Hash)>] InlineResponse20017 data, response status code and response headers
    def post_ips_start_warmup_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_ips_start_warmup ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_ips_start_warmup"
      end
      # resource path
      local_var_path = '/ips/start-warmup'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20017')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_ips_start_warmup\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/cancel-scheduled
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20032>]
    def post_messages_cancel_scheduled(body, opts = {})
      data, _status_code, _headers = post_messages_cancel_scheduled_with_http_info(body, opts)
      data
    end

    # /messages/cancel-scheduled
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20032>, Fixnum, Hash)>] Array<InlineResponse20032> data, response status code and response headers
    def post_messages_cancel_scheduled_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_cancel_scheduled ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_cancel_scheduled"
      end
      # resource path
      local_var_path = '/messages/cancel-scheduled'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20032>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_cancel_scheduled\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/content
    # Get the full content of a recently sent message
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20030]
    def post_messages_content(body, opts = {})
      data, _status_code, _headers = post_messages_content_with_http_info(body, opts)
      data
    end

    # /messages/content
    # Get the full content of a recently sent message
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20030, Fixnum, Hash)>] InlineResponse20030 data, response status code and response headers
    def post_messages_content_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_content ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_content"
      end
      # resource path
      local_var_path = '/messages/content'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20030')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_content\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/info
    # Get the information for a single recently sent message
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20029]
    def post_messages_info(body, opts = {})
      data, _status_code, _headers = post_messages_info_with_http_info(body, opts)
      data
    end

    # /messages/info
    # Get the information for a single recently sent message
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20029, Fixnum, Hash)>] InlineResponse20029 data, response status code and response headers
    def post_messages_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_info"
      end
      # resource path
      local_var_path = '/messages/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20029')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/list-scheduled
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20032>]
    def post_messages_list_scheduled(body, opts = {})
      data, _status_code, _headers = post_messages_list_scheduled_with_http_info(body, opts)
      data
    end

    # /messages/list-scheduled
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20032>, Fixnum, Hash)>] Array<InlineResponse20032> data, response status code and response headers
    def post_messages_list_scheduled_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_list_scheduled ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_list_scheduled"
      end
      # resource path
      local_var_path = '/messages/list-scheduled'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20032>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_list_scheduled\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/parse
    # Parse the full MIME document for an email message, returning the content of the message broken into its constituent pieces
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20031]
    def post_messages_parse(body, opts = {})
      data, _status_code, _headers = post_messages_parse_with_http_info(body, opts)
      data
    end

    # /messages/parse
    # Parse the full MIME document for an email message, returning the content of the message broken into its constituent pieces
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20031, Fixnum, Hash)>] InlineResponse20031 data, response status code and response headers
    def post_messages_parse_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_parse ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_parse"
      end
      # resource path
      local_var_path = '/messages/parse'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20031')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_parse\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/reschedule
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20032>]
    def post_messages_reschedule(body, opts = {})
      data, _status_code, _headers = post_messages_reschedule_with_http_info(body, opts)
      data
    end

    # /messages/reschedule
    # Queries your scheduled emails.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20032>, Fixnum, Hash)>] Array<InlineResponse20032> data, response status code and response headers
    def post_messages_reschedule_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_reschedule ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_reschedule"
      end
      # resource path
      local_var_path = '/messages/reschedule'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20032>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_reschedule\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/search
    # Search recently sent messages and optionally narrow by date range, tags, senders, and API keys. If no date range is specified, results within the last 7 days are returned. This method may be called up to 20 times per minute. If you need the data more often, you can use /messages/info.json to get the information for a single message, or webhooks to push activity to your own application for querying.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20027>]
    def post_messages_search(body, opts = {})
      data, _status_code, _headers = post_messages_search_with_http_info(body, opts)
      data
    end

    # /messages/search
    # Search recently sent messages and optionally narrow by date range, tags, senders, and API keys. If no date range is specified, results within the last 7 days are returned. This method may be called up to 20 times per minute. If you need the data more often, you can use /messages/info.json to get the information for a single message, or webhooks to push activity to your own application for querying.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20027>, Fixnum, Hash)>] Array<InlineResponse20027> data, response status code and response headers
    def post_messages_search_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_search ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_search"
      end
      # resource path
      local_var_path = '/messages/search'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20027>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_search\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/search-time-series
    # Search the content of recently sent messages and return the aggregated hourly stats for matching messages
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20028>]
    def post_messages_search_time_series(body, opts = {})
      data, _status_code, _headers = post_messages_search_time_series_with_http_info(body, opts)
      data
    end

    # /messages/search-time-series
    # Search the content of recently sent messages and return the aggregated hourly stats for matching messages
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20028>, Fixnum, Hash)>] Array<InlineResponse20028> data, response status code and response headers
    def post_messages_search_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_search_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_search_time_series"
      end
      # resource path
      local_var_path = '/messages/search-time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20028>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_search_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/send
    # Send a new transactional message through Mandrill
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20025>]
    def post_messages_send(body, opts = {})
      data, _status_code, _headers = post_messages_send_with_http_info(body, opts)
      data
    end

    # /messages/send
    # Send a new transactional message through Mandrill
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20025>, Fixnum, Hash)>] Array<InlineResponse20025> data, response status code and response headers
    def post_messages_send_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_send ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_send"
      end
      # resource path
      local_var_path = '/messages/send'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20025>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_send\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/send-raw
    # Take a raw MIME document for a message, and send it exactly as if it were sent through Mandrill's SMTP servers
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def post_messages_send_raw(body, opts = {})
      data, _status_code, _headers = post_messages_send_raw_with_http_info(body, opts)
      data
    end

    # /messages/send-raw
    # Take a raw MIME document for a message, and send it exactly as if it were sent through Mandrill&#39;s SMTP servers
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def post_messages_send_raw_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_send_raw ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_send_raw"
      end
      # resource path
      local_var_path = '/messages/send-raw'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_send_raw\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /messages/send-template
    # Send a new transactional message through Mandrill
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20026>]
    def post_messages_send_template(body, opts = {})
      data, _status_code, _headers = post_messages_send_template_with_http_info(body, opts)
      data
    end

    # /messages/send-template
    # Send a new transactional message through Mandrill
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20026>, Fixnum, Hash)>] Array<InlineResponse20026> data, response status code and response headers
    def post_messages_send_template_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_messages_send_template ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_messages_send_template"
      end
      # resource path
      local_var_path = '/messages/send-template'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20026>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_messages_send_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /metadata/add
    # Add a new custom metadata field to be indexed for the account.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20034]
    def post_metadata_add(body, opts = {})
      data, _status_code, _headers = post_metadata_add_with_http_info(body, opts)
      data
    end

    # /metadata/add
    # Add a new custom metadata field to be indexed for the account.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20034, Fixnum, Hash)>] InlineResponse20034 data, response status code and response headers
    def post_metadata_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_metadata_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_metadata_add"
      end
      # resource path
      local_var_path = '/metadata/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20034')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_metadata_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /metadata/delete
    # Delete an existing custom metadata field. Deletion isn't instataneous, and /metadata/list will continue to return the field until the asynchronous deletion process is complete.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20036]
    def post_metadata_delete(body, opts = {})
      data, _status_code, _headers = post_metadata_delete_with_http_info(body, opts)
      data
    end

    # /metadata/delete
    # Delete an existing custom metadata field. Deletion isn&#39;t instataneous, and /metadata/list will continue to return the field until the asynchronous deletion process is complete.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20036, Fixnum, Hash)>] InlineResponse20036 data, response status code and response headers
    def post_metadata_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_metadata_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_metadata_delete"
      end
      # resource path
      local_var_path = '/metadata/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20036')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_metadata_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /metadata/list
    # Get the list of custom metadata fields indexed for the account.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20033>]
    def post_metadata_list(body, opts = {})
      data, _status_code, _headers = post_metadata_list_with_http_info(body, opts)
      data
    end

    # /metadata/list
    # Get the list of custom metadata fields indexed for the account.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20033>, Fixnum, Hash)>] Array<InlineResponse20033> data, response status code and response headers
    def post_metadata_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_metadata_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_metadata_list"
      end
      # resource path
      local_var_path = '/metadata/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20033>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_metadata_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /metadata/update
    # Delete an existing custom metadata field. Deletion isn't instataneous, and /metadata/list will continue to return the field until the asynchronous deletion process is complete.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20035]
    def post_metadata_update(body, opts = {})
      data, _status_code, _headers = post_metadata_update_with_http_info(body, opts)
      data
    end

    # /metadata/update
    # Delete an existing custom metadata field. Deletion isn&#39;t instataneous, and /metadata/list will continue to return the field until the asynchronous deletion process is complete.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20035, Fixnum, Hash)>] InlineResponse20035 data, response status code and response headers
    def post_metadata_update_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_metadata_update ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_metadata_update"
      end
      # resource path
      local_var_path = '/metadata/update'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20035')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_metadata_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /rejects/add
    # Adds an email to your email rejection blacklist. Addresses that you add manually will never expire and there is no reputation penalty for removing them from your blacklist. Attempting to blacklist an address that has been whitelisted will have no effect.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20037]
    def post_rejects_add(body, opts = {})
      data, _status_code, _headers = post_rejects_add_with_http_info(body, opts)
      data
    end

    # /rejects/add
    # Adds an email to your email rejection blacklist. Addresses that you add manually will never expire and there is no reputation penalty for removing them from your blacklist. Attempting to blacklist an address that has been whitelisted will have no effect.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20037, Fixnum, Hash)>] InlineResponse20037 data, response status code and response headers
    def post_rejects_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_rejects_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_rejects_add"
      end
      # resource path
      local_var_path = '/rejects/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20037')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_rejects_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /rejects/delete
    # Deletes an email rejection. There is no limit to how many rejections you can remove from your blacklist, but keep in mind that each deletion has an affect on your reputation.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20039]
    def post_rejects_delete(body, opts = {})
      data, _status_code, _headers = post_rejects_delete_with_http_info(body, opts)
      data
    end

    # /rejects/delete
    # Deletes an email rejection. There is no limit to how many rejections you can remove from your blacklist, but keep in mind that each deletion has an affect on your reputation.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20039, Fixnum, Hash)>] InlineResponse20039 data, response status code and response headers
    def post_rejects_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_rejects_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_rejects_delete"
      end
      # resource path
      local_var_path = '/rejects/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20039')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_rejects_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /rejects/list
    # Retrieves your email rejection blacklist. You can provide an email address to limit the results. Returns up to 1000 results. By default, entries that have expired are excluded from the results; set include_expired to true to include them.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20038>]
    def post_rejects_list(body, opts = {})
      data, _status_code, _headers = post_rejects_list_with_http_info(body, opts)
      data
    end

    # /rejects/list
    # Retrieves your email rejection blacklist. You can provide an email address to limit the results. Returns up to 1000 results. By default, entries that have expired are excluded from the results; set include_expired to true to include them.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20038>, Fixnum, Hash)>] Array<InlineResponse20038> data, response status code and response headers
    def post_rejects_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_rejects_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_rejects_list"
      end
      # resource path
      local_var_path = '/rejects/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20038>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_rejects_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/add-domain
    # Adds a sender domain to your account. Sender domains are added automatically as you send, but you can use this call to add them ahead of time.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20042]
    def post_senders_add_domain(body, opts = {})
      data, _status_code, _headers = post_senders_add_domain_with_http_info(body, opts)
      data
    end

    # /senders/add-domain
    # Adds a sender domain to your account. Sender domains are added automatically as you send, but you can use this call to add them ahead of time.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20042, Fixnum, Hash)>] InlineResponse20042 data, response status code and response headers
    def post_senders_add_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_add_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_add_domain"
      end
      # resource path
      local_var_path = '/senders/add-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20042')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_add_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/check-domain
    # Checks the SPF and DKIM settings for a domain. If you haven't already added this domain to your account, it will be added automatically.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20043]
    def post_senders_check_domain(body, opts = {})
      data, _status_code, _headers = post_senders_check_domain_with_http_info(body, opts)
      data
    end

    # /senders/check-domain
    # Checks the SPF and DKIM settings for a domain. If you haven&#39;t already added this domain to your account, it will be added automatically.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20043, Fixnum, Hash)>] InlineResponse20043 data, response status code and response headers
    def post_senders_check_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_check_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_check_domain"
      end
      # resource path
      local_var_path = '/senders/check-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20043')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_check_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/domains
    # Returns the sender domains that have been added to this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20041>]
    def post_senders_domains(body, opts = {})
      data, _status_code, _headers = post_senders_domains_with_http_info(body, opts)
      data
    end

    # /senders/domains
    # Returns the sender domains that have been added to this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20041>, Fixnum, Hash)>] Array<InlineResponse20041> data, response status code and response headers
    def post_senders_domains_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_domains ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_domains"
      end
      # resource path
      local_var_path = '/senders/domains'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20041>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_domains\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/info
    # Return more detailed information about a single sender, including aggregates of recent stats
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20045]
    def post_senders_info(body, opts = {})
      data, _status_code, _headers = post_senders_info_with_http_info(body, opts)
      data
    end

    # /senders/info
    # Return more detailed information about a single sender, including aggregates of recent stats
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20045, Fixnum, Hash)>] InlineResponse20045 data, response status code and response headers
    def post_senders_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_info"
      end
      # resource path
      local_var_path = '/senders/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20045')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/list
    # Return the senders that have tried to use this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20040>]
    def post_senders_list(body, opts = {})
      data, _status_code, _headers = post_senders_list_with_http_info(body, opts)
      data
    end

    # /senders/list
    # Return the senders that have tried to use this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20040>, Fixnum, Hash)>] Array<InlineResponse20040> data, response status code and response headers
    def post_senders_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_list"
      end
      # resource path
      local_var_path = '/senders/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20040>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/time-series
    # Return the recent history (hourly stats for the last 30 days) for a sender
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20046>]
    def post_senders_time_series(body, opts = {})
      data, _status_code, _headers = post_senders_time_series_with_http_info(body, opts)
      data
    end

    # /senders/time-series
    # Return the recent history (hourly stats for the last 30 days) for a sender
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20046>, Fixnum, Hash)>] Array<InlineResponse20046> data, response status code and response headers
    def post_senders_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_time_series"
      end
      # resource path
      local_var_path = '/senders/time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20046>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /senders/verify-domain
    # Sends a verification email in order to verify ownership of a domain. Domain verification is a required step to confirm ownership of a domain. Once a domain has been verified in a Mandrill account, other accounts may not have their messages signed by that domain unless they also verify the domain. This prevents other Mandrill accounts from sending mail signed by your domain.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20044]
    def post_senders_verify_domain(body, opts = {})
      data, _status_code, _headers = post_senders_verify_domain_with_http_info(body, opts)
      data
    end

    # /senders/verify-domain
    # Sends a verification email in order to verify ownership of a domain. Domain verification is a required step to confirm ownership of a domain. Once a domain has been verified in a Mandrill account, other accounts may not have their messages signed by that domain unless they also verify the domain. This prevents other Mandrill accounts from sending mail signed by your domain.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20044, Fixnum, Hash)>] InlineResponse20044 data, response status code and response headers
    def post_senders_verify_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_senders_verify_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_senders_verify_domain"
      end
      # resource path
      local_var_path = '/senders/verify-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20044')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_senders_verify_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/add
    # Add a new subaccount
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20048]
    def post_subaccounts_add(body, opts = {})
      data, _status_code, _headers = post_subaccounts_add_with_http_info(body, opts)
      data
    end

    # /subaccounts/add
    # Add a new subaccount
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20048, Fixnum, Hash)>] InlineResponse20048 data, response status code and response headers
    def post_subaccounts_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_add"
      end
      # resource path
      local_var_path = '/subaccounts/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20048')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/delete
    # Delete an existing subaccount. Any email related to the subaccount will be saved, but stats will be removed and any future sending calls to this subaccount will fail.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20051]
    def post_subaccounts_delete(body, opts = {})
      data, _status_code, _headers = post_subaccounts_delete_with_http_info(body, opts)
      data
    end

    # /subaccounts/delete
    # Delete an existing subaccount. Any email related to the subaccount will be saved, but stats will be removed and any future sending calls to this subaccount will fail.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20051, Fixnum, Hash)>] InlineResponse20051 data, response status code and response headers
    def post_subaccounts_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_delete"
      end
      # resource path
      local_var_path = '/subaccounts/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20051')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/info
    # Given the ID of an existing subaccount, return the data about it
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20049]
    def post_subaccounts_info(body, opts = {})
      data, _status_code, _headers = post_subaccounts_info_with_http_info(body, opts)
      data
    end

    # /subaccounts/info
    # Given the ID of an existing subaccount, return the data about it
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20049, Fixnum, Hash)>] InlineResponse20049 data, response status code and response headers
    def post_subaccounts_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_info"
      end
      # resource path
      local_var_path = '/subaccounts/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20049')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/list
    # Get the list of subaccounts defined for the account, optionally filtered by a prefix
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20047>]
    def post_subaccounts_list(body, opts = {})
      data, _status_code, _headers = post_subaccounts_list_with_http_info(body, opts)
      data
    end

    # /subaccounts/list
    # Get the list of subaccounts defined for the account, optionally filtered by a prefix
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20047>, Fixnum, Hash)>] Array<InlineResponse20047> data, response status code and response headers
    def post_subaccounts_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_list"
      end
      # resource path
      local_var_path = '/subaccounts/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20047>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/pause
    # Pause a subaccount's sending. Any future emails delivered to this subaccount will be queued for a maximum of 3 days until the subaccount is resumed.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20052]
    def post_subaccounts_pause(body, opts = {})
      data, _status_code, _headers = post_subaccounts_pause_with_http_info(body, opts)
      data
    end

    # /subaccounts/pause
    # Pause a subaccount&#39;s sending. Any future emails delivered to this subaccount will be queued for a maximum of 3 days until the subaccount is resumed.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20052, Fixnum, Hash)>] InlineResponse20052 data, response status code and response headers
    def post_subaccounts_pause_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_pause ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_pause"
      end
      # resource path
      local_var_path = '/subaccounts/pause'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20052')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_pause\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/resume
    # Resume a paused subaccount's sending
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20053]
    def post_subaccounts_resume(body, opts = {})
      data, _status_code, _headers = post_subaccounts_resume_with_http_info(body, opts)
      data
    end

    # /subaccounts/resume
    # Resume a paused subaccount&#39;s sending
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20053, Fixnum, Hash)>] InlineResponse20053 data, response status code and response headers
    def post_subaccounts_resume_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_resume ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_resume"
      end
      # resource path
      local_var_path = '/subaccounts/resume'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20053')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_resume\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /subaccounts/update
    # Update an existing subaccount
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20050]
    def post_subaccounts_update(body, opts = {})
      data, _status_code, _headers = post_subaccounts_update_with_http_info(body, opts)
      data
    end

    # /subaccounts/update
    # Update an existing subaccount
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20050, Fixnum, Hash)>] InlineResponse20050 data, response status code and response headers
    def post_subaccounts_update_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_subaccounts_update ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_subaccounts_update"
      end
      # resource path
      local_var_path = '/subaccounts/update'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20050')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_subaccounts_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /tags/all-time-series
    # Return the recent history (hourly stats for the last 30 days) for all tags
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20028>]
    def post_tags_all_time_series(body, opts = {})
      data, _status_code, _headers = post_tags_all_time_series_with_http_info(body, opts)
      data
    end

    # /tags/all-time-series
    # Return the recent history (hourly stats for the last 30 days) for all tags
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20028>, Fixnum, Hash)>] Array<InlineResponse20028> data, response status code and response headers
    def post_tags_all_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_tags_all_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_tags_all_time_series"
      end
      # resource path
      local_var_path = '/tags/all-time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20028>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_tags_all_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /tags/delete
    # Deletes a tag permanently. Deleting a tag removes the tag from any messages that have been sent, and also deletes the tag's stats. There is no way to undo this operation, so use it carefully.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20055]
    def post_tags_delete(body, opts = {})
      data, _status_code, _headers = post_tags_delete_with_http_info(body, opts)
      data
    end

    # /tags/delete
    # Deletes a tag permanently. Deleting a tag removes the tag from any messages that have been sent, and also deletes the tag&#39;s stats. There is no way to undo this operation, so use it carefully.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20055, Fixnum, Hash)>] InlineResponse20055 data, response status code and response headers
    def post_tags_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_tags_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_tags_delete"
      end
      # resource path
      local_var_path = '/tags/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20055')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_tags_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /tags/info
    # Return more detailed information about a single tag, including aggregates of recent stats
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20056]
    def post_tags_info(body, opts = {})
      data, _status_code, _headers = post_tags_info_with_http_info(body, opts)
      data
    end

    # /tags/info
    # Return more detailed information about a single tag, including aggregates of recent stats
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20056, Fixnum, Hash)>] InlineResponse20056 data, response status code and response headers
    def post_tags_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_tags_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_tags_info"
      end
      # resource path
      local_var_path = '/tags/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20056')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_tags_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /tags/list
    # Return all of the user-defined tag information
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20054>]
    def post_tags_list(body, opts = {})
      data, _status_code, _headers = post_tags_list_with_http_info(body, opts)
      data
    end

    # /tags/list
    # Return all of the user-defined tag information
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20054>, Fixnum, Hash)>] Array<InlineResponse20054> data, response status code and response headers
    def post_tags_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_tags_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_tags_list"
      end
      # resource path
      local_var_path = '/tags/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20054>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_tags_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /tags/time-series
    # Return the recent history (hourly stats for the last 30 days) for a tag
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20028>]
    def post_tags_time_series(body, opts = {})
      data, _status_code, _headers = post_tags_time_series_with_http_info(body, opts)
      data
    end

    # /tags/time-series
    # Return the recent history (hourly stats for the last 30 days) for a tag
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20028>, Fixnum, Hash)>] Array<InlineResponse20028> data, response status code and response headers
    def post_tags_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_tags_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_tags_time_series"
      end
      # resource path
      local_var_path = '/tags/time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20028>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_tags_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/add
    # Add a new template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20057]
    def post_templates_add(body, opts = {})
      data, _status_code, _headers = post_templates_add_with_http_info(body, opts)
      data
    end

    # /templates/add
    # Add a new template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20057, Fixnum, Hash)>] InlineResponse20057 data, response status code and response headers
    def post_templates_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_add"
      end
      # resource path
      local_var_path = '/templates/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20057')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/delete
    # Delete a template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20061]
    def post_templates_delete(body, opts = {})
      data, _status_code, _headers = post_templates_delete_with_http_info(body, opts)
      data
    end

    # /templates/delete
    # Delete a template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20061, Fixnum, Hash)>] InlineResponse20061 data, response status code and response headers
    def post_templates_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_delete"
      end
      # resource path
      local_var_path = '/templates/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20061')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/info
    # Get the information for an existing template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20058]
    def post_templates_info(body, opts = {})
      data, _status_code, _headers = post_templates_info_with_http_info(body, opts)
      data
    end

    # /templates/info
    # Get the information for an existing template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20058, Fixnum, Hash)>] InlineResponse20058 data, response status code and response headers
    def post_templates_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_info"
      end
      # resource path
      local_var_path = '/templates/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20058')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/list
    # Return a list of all the templates available to this user
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20062>]
    def post_templates_list(body, opts = {})
      data, _status_code, _headers = post_templates_list_with_http_info(body, opts)
      data
    end

    # /templates/list
    # Return a list of all the templates available to this user
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20062>, Fixnum, Hash)>] Array<InlineResponse20062> data, response status code and response headers
    def post_templates_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_list"
      end
      # resource path
      local_var_path = '/templates/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20062>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/publish
    # Publish the content for the template. Any new messages sent using this template will start using the content that was previously in draft.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20060]
    def post_templates_publish(body, opts = {})
      data, _status_code, _headers = post_templates_publish_with_http_info(body, opts)
      data
    end

    # /templates/publish
    # Publish the content for the template. Any new messages sent using this template will start using the content that was previously in draft.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20060, Fixnum, Hash)>] InlineResponse20060 data, response status code and response headers
    def post_templates_publish_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_publish ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_publish"
      end
      # resource path
      local_var_path = '/templates/publish'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20060')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_publish\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/render
    # Inject content and optionally merge fields into a template, returning the HTML that results
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20063]
    def post_templates_render(body, opts = {})
      data, _status_code, _headers = post_templates_render_with_http_info(body, opts)
      data
    end

    # /templates/render
    # Inject content and optionally merge fields into a template, returning the HTML that results
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20063, Fixnum, Hash)>] InlineResponse20063 data, response status code and response headers
    def post_templates_render_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_render ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_render"
      end
      # resource path
      local_var_path = '/templates/render'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20063')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_render\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/time-series
    # Return the recent history (hourly stats for the last 30 days) for a template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20046>]
    def post_templates_time_series(body, opts = {})
      data, _status_code, _headers = post_templates_time_series_with_http_info(body, opts)
      data
    end

    # /templates/time-series
    # Return the recent history (hourly stats for the last 30 days) for a template
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20046>, Fixnum, Hash)>] Array<InlineResponse20046> data, response status code and response headers
    def post_templates_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_time_series"
      end
      # resource path
      local_var_path = '/templates/time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20046>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /templates/update
    # Update the code for an existing template. If null is provided for any fields, the values will remain unchanged.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20059]
    def post_templates_update(body, opts = {})
      data, _status_code, _headers = post_templates_update_with_http_info(body, opts)
      data
    end

    # /templates/update
    # Update the code for an existing template. If null is provided for any fields, the values will remain unchanged.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20059, Fixnum, Hash)>] InlineResponse20059 data, response status code and response headers
    def post_templates_update_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_templates_update ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_templates_update"
      end
      # resource path
      local_var_path = '/templates/update'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20059')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_templates_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/add-tracking-domain
    # Add a tracking domain to your account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20068]
    def post_urls_add_tracking_domain(body, opts = {})
      data, _status_code, _headers = post_urls_add_tracking_domain_with_http_info(body, opts)
      data
    end

    # /urls/add-tracking-domain
    # Add a tracking domain to your account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20068, Fixnum, Hash)>] InlineResponse20068 data, response status code and response headers
    def post_urls_add_tracking_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_add_tracking_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_add_tracking_domain"
      end
      # resource path
      local_var_path = '/urls/add-tracking-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20068')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_add_tracking_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/check-tracking-domain
    # Checks the CNAME settings for a tracking domain. The domain must have been added already with the add-tracking-domain call
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20068]
    def post_urls_check_tracking_domain(body, opts = {})
      data, _status_code, _headers = post_urls_check_tracking_domain_with_http_info(body, opts)
      data
    end

    # /urls/check-tracking-domain
    # Checks the CNAME settings for a tracking domain. The domain must have been added already with the add-tracking-domain call
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20068, Fixnum, Hash)>] InlineResponse20068 data, response status code and response headers
    def post_urls_check_tracking_domain_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_check_tracking_domain ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_check_tracking_domain"
      end
      # resource path
      local_var_path = '/urls/check-tracking-domain'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20068')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_check_tracking_domain\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/list
    # Get the 100 most clicked URLs
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20064>]
    def post_urls_list(body, opts = {})
      data, _status_code, _headers = post_urls_list_with_http_info(body, opts)
      data
    end

    # /urls/list
    # Get the 100 most clicked URLs
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20064>, Fixnum, Hash)>] Array<InlineResponse20064> data, response status code and response headers
    def post_urls_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_list"
      end
      # resource path
      local_var_path = '/urls/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20064>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/search (deprecated)
    # Return the 100 most clicked URLs that match the search query given
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20065>]
    def post_urls_search_deprecated(body, opts = {})
      data, _status_code, _headers = post_urls_search_deprecated_with_http_info(body, opts)
      data
    end

    # /urls/search (deprecated)
    # Return the 100 most clicked URLs that match the search query given
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20065>, Fixnum, Hash)>] Array<InlineResponse20065> data, response status code and response headers
    def post_urls_search_deprecated_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_search_deprecated ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_search_deprecated"
      end
      # resource path
      local_var_path = '/urls/search'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20065>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_search_deprecated\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/time-series
    # Return the recent history (hourly stats for the last 30 days) for a url
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20066>]
    def post_urls_time_series(body, opts = {})
      data, _status_code, _headers = post_urls_time_series_with_http_info(body, opts)
      data
    end

    # /urls/time-series
    # Return the recent history (hourly stats for the last 30 days) for a url
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20066>, Fixnum, Hash)>] Array<InlineResponse20066> data, response status code and response headers
    def post_urls_time_series_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_time_series ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_time_series"
      end
      # resource path
      local_var_path = '/urls/time-series'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20066>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_time_series\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /urls/tracking-domains
    # Get the list of tracking domains set up for this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20067>]
    def post_urls_tracking_domains(body, opts = {})
      data, _status_code, _headers = post_urls_tracking_domains_with_http_info(body, opts)
      data
    end

    # /urls/tracking-domains
    # Get the list of tracking domains set up for this account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20067>, Fixnum, Hash)>] Array<InlineResponse20067> data, response status code and response headers
    def post_urls_tracking_domains_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_urls_tracking_domains ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_urls_tracking_domains"
      end
      # resource path
      local_var_path = '/urls/tracking-domains'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20067>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_urls_tracking_domains\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /users/info
    # Return the information about the API-connected user
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20069]
    def post_users_info(body, opts = {})
      data, _status_code, _headers = post_users_info_with_http_info(body, opts)
      data
    end

    # /users/info
    # Return the information about the API-connected user
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20069, Fixnum, Hash)>] InlineResponse20069 data, response status code and response headers
    def post_users_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_users_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_users_info"
      end
      # resource path
      local_var_path = '/users/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20069')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_users_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /users/ping
    # Validate an API key and respond to a ping
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [String]
    def post_users_ping(body, opts = {})
      data, _status_code, _headers = post_users_ping_with_http_info(body, opts)
      data
    end

    # /users/ping
    # Validate an API key and respond to a ping
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_users_ping_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_users_ping ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_users_ping"
      end
      # resource path
      local_var_path = '/users/ping'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_users_ping\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /users/ping2
    # Validate an API key and respond to a ping (anal JSON parser version)
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20070]
    def post_users_ping2(body, opts = {})
      data, _status_code, _headers = post_users_ping2_with_http_info(body, opts)
      data
    end

    # /users/ping2
    # Validate an API key and respond to a ping (anal JSON parser version)
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20070, Fixnum, Hash)>] InlineResponse20070 data, response status code and response headers
    def post_users_ping2_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_users_ping2 ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_users_ping2"
      end
      # resource path
      local_var_path = '/users/ping2'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20070')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_users_ping2\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /users/senders
    # Return the senders that have tried to use this account, both verified and unverified
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20040>]
    def post_users_senders(body, opts = {})
      data, _status_code, _headers = post_users_senders_with_http_info(body, opts)
      data
    end

    # /users/senders
    # Return the senders that have tried to use this account, both verified and unverified
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20040>, Fixnum, Hash)>] Array<InlineResponse20040> data, response status code and response headers
    def post_users_senders_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_users_senders ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_users_senders"
      end
      # resource path
      local_var_path = '/users/senders'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20040>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_users_senders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /webhooks/add
    # Add a new webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20072]
    def post_webhooks_add(body, opts = {})
      data, _status_code, _headers = post_webhooks_add_with_http_info(body, opts)
      data
    end

    # /webhooks/add
    # Add a new webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20072, Fixnum, Hash)>] InlineResponse20072 data, response status code and response headers
    def post_webhooks_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_webhooks_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_webhooks_add"
      end
      # resource path
      local_var_path = '/webhooks/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20072')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_webhooks_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /webhooks/delete
    # Delete an existing webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20075]
    def post_webhooks_delete(body, opts = {})
      data, _status_code, _headers = post_webhooks_delete_with_http_info(body, opts)
      data
    end

    # /webhooks/delete
    # Delete an existing webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20075, Fixnum, Hash)>] InlineResponse20075 data, response status code and response headers
    def post_webhooks_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_webhooks_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_webhooks_delete"
      end
      # resource path
      local_var_path = '/webhooks/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20075')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_webhooks_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /webhooks/info
    # Given the ID of an existing webhook, return the data about it
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20073]
    def post_webhooks_info(body, opts = {})
      data, _status_code, _headers = post_webhooks_info_with_http_info(body, opts)
      data
    end

    # /webhooks/info
    # Given the ID of an existing webhook, return the data about it
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20073, Fixnum, Hash)>] InlineResponse20073 data, response status code and response headers
    def post_webhooks_info_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_webhooks_info ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_webhooks_info"
      end
      # resource path
      local_var_path = '/webhooks/info'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20073')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_webhooks_info\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /webhooks/list
    # Get the list of all webhooks defined on the account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20071>]
    def post_webhooks_list(body, opts = {})
      data, _status_code, _headers = post_webhooks_list_with_http_info(body, opts)
      data
    end

    # /webhooks/list
    # Get the list of all webhooks defined on the account
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20071>, Fixnum, Hash)>] Array<InlineResponse20071> data, response status code and response headers
    def post_webhooks_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_webhooks_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_webhooks_list"
      end
      # resource path
      local_var_path = '/webhooks/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20071>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_webhooks_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /webhooks/update
    # Update an existing webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20074]
    def post_webhooks_update(body, opts = {})
      data, _status_code, _headers = post_webhooks_update_with_http_info(body, opts)
      data
    end

    # /webhooks/update
    # Update an existing webhook
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20074, Fixnum, Hash)>] InlineResponse20074 data, response status code and response headers
    def post_webhooks_update_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_webhooks_update ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_webhooks_update"
      end
      # resource path
      local_var_path = '/webhooks/update'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20074')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_webhooks_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /whitelists/add
    # Adds an email to your email rejection whitelist. If the address is currently on your blacklist, that blacklist entry will be removed automatically.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20076]
    def post_whitelists_add(body, opts = {})
      data, _status_code, _headers = post_whitelists_add_with_http_info(body, opts)
      data
    end

    # /whitelists/add
    # Adds an email to your email rejection whitelist. If the address is currently on your blacklist, that blacklist entry will be removed automatically.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20076, Fixnum, Hash)>] InlineResponse20076 data, response status code and response headers
    def post_whitelists_add_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_whitelists_add ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_whitelists_add"
      end
      # resource path
      local_var_path = '/whitelists/add'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20076')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_whitelists_add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /whitelists/delete
    # Removes an email address from the whitelist.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [InlineResponse20078]
    def post_whitelists_delete(body, opts = {})
      data, _status_code, _headers = post_whitelists_delete_with_http_info(body, opts)
      data
    end

    # /whitelists/delete
    # Removes an email address from the whitelist.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(InlineResponse20078, Fixnum, Hash)>] InlineResponse20078 data, response status code and response headers
    def post_whitelists_delete_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_whitelists_delete ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_whitelists_delete"
      end
      # resource path
      local_var_path = '/whitelists/delete'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse20078')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_whitelists_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # /whitelists/list
    # Retrieves your email rejection whitelist. You can provide an email address or search prefix to limit the results. Returns up to 1000 results.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<InlineResponse20077>]
    def post_whitelists_list(body, opts = {})
      data, _status_code, _headers = post_whitelists_list_with_http_info(body, opts)
      data
    end

    # /whitelists/list
    # Retrieves your email rejection whitelist. You can provide an email address or search prefix to limit the results. Returns up to 1000 results.
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<InlineResponse20077>, Fixnum, Hash)>] Array<InlineResponse20077> data, response status code and response headers
    def post_whitelists_list_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TransactionalApi.post_whitelists_list ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling TransactionalApi.post_whitelists_list"
      end
      # resource path
      local_var_path = '/whitelists/list'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<InlineResponse20077>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TransactionalApi#post_whitelists_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
