=begin
#Mandrill API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0
Contact: apihelp@mandrill.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module MailchimpTransactional
  # the information for the resumed subaccount
  class InlineResponse20053
    # a unique indentifier for the subaccount
    attr_accessor :id

    # an optional display name for the subaccount
    attr_accessor :name

    # an optional manual hourly quota for the subaccount. If not specified, the hourly quota will be managed based on reputation
    attr_accessor :custom_quota

    # the current sending status of the subaccount
    attr_accessor :status

    # the subaccount's current reputation on a scale from 0 to 100
    attr_accessor :reputation

    # the date and time that the subaccount was created as a UTC string in YYYY-MM-DD HH:MM:SS format
    attr_accessor :created_at

    # the date and time that the subaccount first sent as a UTC string in YYYY-MM-DD HH:MM:SS format
    attr_accessor :first_sent_at

    # the number of emails the subaccount has sent so far this week (weeks start on midnight Monday, UTC)
    attr_accessor :sent_weekly

    # the number of emails the subaccount has sent so far this month (months start on midnight of the 1st, UTC)
    attr_accessor :sent_monthly

    # the number of emails the subaccount has sent since it was created
    attr_accessor :sent_total

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'name' => :'name',
        :'custom_quota' => :'custom_quota',
        :'status' => :'status',
        :'reputation' => :'reputation',
        :'created_at' => :'created_at',
        :'first_sent_at' => :'first_sent_at',
        :'sent_weekly' => :'sent_weekly',
        :'sent_monthly' => :'sent_monthly',
        :'sent_total' => :'sent_total'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'String',
        :'name' => :'String',
        :'custom_quota' => :'Integer',
        :'status' => :'String',
        :'reputation' => :'Integer',
        :'created_at' => :'DateTime',
        :'first_sent_at' => :'DateTime',
        :'sent_weekly' => :'Integer',
        :'sent_monthly' => :'Integer',
        :'sent_total' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'custom_quota')
        self.custom_quota = attributes[:'custom_quota']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'reputation')
        self.reputation = attributes[:'reputation']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'first_sent_at')
        self.first_sent_at = attributes[:'first_sent_at']
      end

      if attributes.has_key?(:'sent_weekly')
        self.sent_weekly = attributes[:'sent_weekly']
      end

      if attributes.has_key?(:'sent_monthly')
        self.sent_monthly = attributes[:'sent_monthly']
      end

      if attributes.has_key?(:'sent_total')
        self.sent_total = attributes[:'sent_total']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@reputation.nil? && @reputation > 100
        invalid_properties.push('invalid value for "reputation", must be smaller than or equal to 100.')
      end

      if !@reputation.nil? && @reputation < 0
        invalid_properties.push('invalid value for "reputation", must be greater than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      status_validator = EnumAttributeValidator.new('String', ['active', 'paused'])
      return false unless status_validator.valid?(@status)
      return false if !@reputation.nil? && @reputation > 100
      return false if !@reputation.nil? && @reputation < 0
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['active', 'paused'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Custom attribute writer method with validation
    # @param [Object] reputation Value to be assigned
    def reputation=(reputation)
      if !reputation.nil? && reputation > 100
        fail ArgumentError, 'invalid value for "reputation", must be smaller than or equal to 100.'
      end

      if !reputation.nil? && reputation < 0
        fail ArgumentError, 'invalid value for "reputation", must be greater than or equal to 0.'
      end

      @reputation = reputation
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          custom_quota == o.custom_quota &&
          status == o.status &&
          reputation == o.reputation &&
          created_at == o.created_at &&
          first_sent_at == o.first_sent_at &&
          sent_weekly == o.sent_weekly &&
          sent_monthly == o.sent_monthly &&
          sent_total == o.sent_total
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, custom_quota, status, reputation, created_at, first_sent_at, sent_weekly, sent_monthly, sent_total].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = MailchimpTransactional.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
