=begin
#Mandrill API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0
Contact: apihelp@mandrill.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module MailchimpTransactional
  # the information saved about the new template
  class InlineResponse20057
    # the immutable unique code name of the template
    attr_accessor :slug

    # the name of the template
    attr_accessor :name

    # the list of labels applied to the template
    attr_accessor :labels

    # the full HTML code of the template, with mc:edit attributes marking the editable elements - draft version
    attr_accessor :code

    # the subject line of the template, if provided - draft version
    attr_accessor :subject

    # the default sender address for the template, if provided - draft version
    attr_accessor :from_email

    # the default sender from name for the template, if provided - draft version
    attr_accessor :from_name

    # the default text part of messages sent with the template, if provided - draft version
    attr_accessor :text

    # the same as the template name - kept as a separate field for backwards compatibility
    attr_accessor :publish_name

    # the full HTML code of the template, with mc:edit attributes marking the editable elements that are available as published, if it has been published
    attr_accessor :publish_code

    # the subject line of the template, if provided
    attr_accessor :publish_subject

    # the default sender address for the template, if provided
    attr_accessor :publish_from_email

    # the default sender from name for the template, if provided
    attr_accessor :publish_from_name

    # the default text part of messages sent with the template, if provided
    attr_accessor :publish_text

    # the date and time the template was last published as a UTC string in YYYY-MM-DD HH:MM:SS format, or null if it has not been published
    attr_accessor :published_at

    # the date and time the template was first created as a UTC string in YYYY-MM-DD HH:MM:SS format
    attr_accessor :created_at

    # the date and time the template was last modified as a UTC string in YYYY-MM-DD HH:MM:SS format
    attr_accessor :updated_at

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'slug' => :'slug',
        :'name' => :'name',
        :'labels' => :'labels',
        :'code' => :'code',
        :'subject' => :'subject',
        :'from_email' => :'from_email',
        :'from_name' => :'from_name',
        :'text' => :'text',
        :'publish_name' => :'publish_name',
        :'publish_code' => :'publish_code',
        :'publish_subject' => :'publish_subject',
        :'publish_from_email' => :'publish_from_email',
        :'publish_from_name' => :'publish_from_name',
        :'publish_text' => :'publish_text',
        :'published_at' => :'published_at',
        :'created_at' => :'created_at',
        :'updated_at' => :'updated_at'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'slug' => :'String',
        :'name' => :'String',
        :'labels' => :'Array<String>',
        :'code' => :'String',
        :'subject' => :'String',
        :'from_email' => :'String',
        :'from_name' => :'String',
        :'text' => :'String',
        :'publish_name' => :'String',
        :'publish_code' => :'String',
        :'publish_subject' => :'String',
        :'publish_from_email' => :'String',
        :'publish_from_name' => :'String',
        :'publish_text' => :'String',
        :'published_at' => :'DateTime',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'slug')
        self.slug = attributes[:'slug']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'labels')
        if (value = attributes[:'labels']).is_a?(Array)
          self.labels = value
        end
      end

      if attributes.has_key?(:'code')
        self.code = attributes[:'code']
      end

      if attributes.has_key?(:'subject')
        self.subject = attributes[:'subject']
      end

      if attributes.has_key?(:'from_email')
        self.from_email = attributes[:'from_email']
      end

      if attributes.has_key?(:'from_name')
        self.from_name = attributes[:'from_name']
      end

      if attributes.has_key?(:'text')
        self.text = attributes[:'text']
      end

      if attributes.has_key?(:'publish_name')
        self.publish_name = attributes[:'publish_name']
      end

      if attributes.has_key?(:'publish_code')
        self.publish_code = attributes[:'publish_code']
      end

      if attributes.has_key?(:'publish_subject')
        self.publish_subject = attributes[:'publish_subject']
      end

      if attributes.has_key?(:'publish_from_email')
        self.publish_from_email = attributes[:'publish_from_email']
      end

      if attributes.has_key?(:'publish_from_name')
        self.publish_from_name = attributes[:'publish_from_name']
      end

      if attributes.has_key?(:'publish_text')
        self.publish_text = attributes[:'publish_text']
      end

      if attributes.has_key?(:'published_at')
        self.published_at = attributes[:'published_at']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          slug == o.slug &&
          name == o.name &&
          labels == o.labels &&
          code == o.code &&
          subject == o.subject &&
          from_email == o.from_email &&
          from_name == o.from_name &&
          text == o.text &&
          publish_name == o.publish_name &&
          publish_code == o.publish_code &&
          publish_subject == o.publish_subject &&
          publish_from_email == o.publish_from_email &&
          publish_from_name == o.publish_from_name &&
          publish_text == o.publish_text &&
          published_at == o.published_at &&
          created_at == o.created_at &&
          updated_at == o.updated_at
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [slug, name, labels, code, subject, from_email, from_name, text, publish_name, publish_code, publish_subject, publish_from_email, publish_from_name, publish_text, published_at, created_at, updated_at].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = MailchimpTransactional.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
