=begin
#Mandrill API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0
Contact: apihelp@mandrill.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module MailchimpTransactional
  # stats for this user in the last 90 days
  class InlineResponse20069StatsLast90Days
    # the number of emails sent for this user in the last 90 days
    attr_accessor :sent

    # the number of emails hard bounced for this user in the last 90 days
    attr_accessor :hard_bounces

    # the number of emails soft bounced for this user in the last 90 days
    attr_accessor :soft_bounces

    # the number of emails rejected for sending this sender in the last 90 days
    attr_accessor :rejects

    # the number of spam complaints for this user in the last 90 days
    attr_accessor :complaints

    # the number of unsubscribes for this user in the last 90 days
    attr_accessor :unsubs

    # the number of times emails have been opened for this user in the last 90 days
    attr_accessor :opens

    # the number of unique opens for emails sent for this user in the last 90 days
    attr_accessor :unique_opens

    # the number of URLs that have been clicked for this user in the last 90 days
    attr_accessor :clicks

    # the number of unique clicks for emails sent for this user in the last 90 days
    attr_accessor :unique_clicks

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'sent' => :'sent',
        :'hard_bounces' => :'hard_bounces',
        :'soft_bounces' => :'soft_bounces',
        :'rejects' => :'rejects',
        :'complaints' => :'complaints',
        :'unsubs' => :'unsubs',
        :'opens' => :'opens',
        :'unique_opens' => :'unique_opens',
        :'clicks' => :'clicks',
        :'unique_clicks' => :'unique_clicks'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'sent' => :'Integer',
        :'hard_bounces' => :'Integer',
        :'soft_bounces' => :'Integer',
        :'rejects' => :'Integer',
        :'complaints' => :'Integer',
        :'unsubs' => :'Integer',
        :'opens' => :'Integer',
        :'unique_opens' => :'Integer',
        :'clicks' => :'Integer',
        :'unique_clicks' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'sent')
        self.sent = attributes[:'sent']
      end

      if attributes.has_key?(:'hard_bounces')
        self.hard_bounces = attributes[:'hard_bounces']
      end

      if attributes.has_key?(:'soft_bounces')
        self.soft_bounces = attributes[:'soft_bounces']
      end

      if attributes.has_key?(:'rejects')
        self.rejects = attributes[:'rejects']
      end

      if attributes.has_key?(:'complaints')
        self.complaints = attributes[:'complaints']
      end

      if attributes.has_key?(:'unsubs')
        self.unsubs = attributes[:'unsubs']
      end

      if attributes.has_key?(:'opens')
        self.opens = attributes[:'opens']
      end

      if attributes.has_key?(:'unique_opens')
        self.unique_opens = attributes[:'unique_opens']
      end

      if attributes.has_key?(:'clicks')
        self.clicks = attributes[:'clicks']
      end

      if attributes.has_key?(:'unique_clicks')
        self.unique_clicks = attributes[:'unique_clicks']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          sent == o.sent &&
          hard_bounces == o.hard_bounces &&
          soft_bounces == o.soft_bounces &&
          rejects == o.rejects &&
          complaints == o.complaints &&
          unsubs == o.unsubs &&
          opens == o.opens &&
          unique_opens == o.unique_opens &&
          clicks == o.clicks &&
          unique_clicks == o.unique_clicks
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [sent, hard_bounces, soft_bounces, rejects, complaints, unsubs, opens, unique_opens, clicks, unique_clicks].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = MailchimpTransactional.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
